#ifndef MDR_UV_RECT_EDITOR_POPUP_H
#define MDR_UV_RECT_EDITOR_POPUP_H

/*
Copyright (c) 2019-2023 Péter Magyar

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/

#include "scene/gui/dialogs.h"

class MDRUVRectEditor;
class MDIEdPlugin;

class MDRUVRectEditorPopup : public ConfirmationDialog {
	GDCLASS(MDRUVRectEditorPopup, ConfirmationDialog);

public:
	void on_ok_pressed();
	void on_cancel_pressed();

	MDRUVRectEditor *get_editor();

	void set_plugin(MDIEdPlugin *plugin);

	MDRUVRectEditorPopup();
	~MDRUVRectEditorPopup();

protected:
	void _notification(int p_what);
	static void _bind_methods();

	MDRUVRectEditor *_editor;
};

#endif
